unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, CuBlasMtxVec, StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Memo2: TMemo;
    Memo3: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Memo4: TMemo;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
   N: integer;
   A, AA: TMtx;
   B,X: TVec;
  end;

var
  Form1: TForm1;
    
implementation

{$R *.dfm}


procedure TForm1.FormCreate(Sender: TObject);
var i,j: integer;
begin
  N:= 100;

  A:= TMtx.Create;
  A.Size(N,N);
  B:= TVec.Create;
  B.Size(N);
  X:= TVec.Create;
  X.Size(N);
  AA:= TMtx.Create;
  AA.Size(N,N);

  Memo1.Clear;
  Memo2.Clear;
  Memo3.Clear;
  Memo4.Clear;
  
  Randomize;
end;

procedure TForm1.Button1Click(Sender: TObject);
var i,j:integer;

begin

  Memo1.Clear;
  Memo2.Clear;
  Memo3.Clear;
  Memo4.Clear;

  for i:= 0 to N-1 do
  begin
   B[i]:= 5 + Random(500)/100 - Random(500)/100;
   X[i]:= 0.0;
  for j:= 0 to N-1 do
   begin
    if i = j then
      A[i,j]:= 0.0 //Random(100)/100 - Random(100)/100
    else
      A[i,j]:= 1 + Random(100)/100 - Random(100)/100;
   end;
  end;

  Memo1.Lines.Add('Valor Matriz A');
  for i:= 0 to N-1 do
   for j:= 0 to N-1 do
    Memo1.Lines.Add('A[' + InttoStr(i) + ',' + InttoStr(j) + '] := '+ FloattoStr(A[i,j]));

  Memo2.Lines.Add('Valor Vector B');
  for i:= 0 to N-1 do
    Memo2.Lines.Add('B[' + InttoStr(i) + '] := '+ FloattoStr(B[i]));


  A.LUSolve(B, X);
  //A.SGMRES(B,X);
  //A.GMRES(B,X);
  //A.AdaptiveSGMRES(B,X);
  //A.BiCGStab(B,X);
  //A.CG(B,X);

  Memo3.Lines.Add('Valor Vector X');
  for i:= 0 to N-1 do
    Memo3.Lines.Add('X[' + InttoStr(i) + '] := '+ FloattoStr(X[i]));

  B:= A.Prod(X);
  Memo4.Lines.Add('Prod B:=A.Prod(X)');
  for i:= 0 to N-1 do
    Memo4.Lines.Add('B[' + InttoStr(i) + '] := '+ FloattoStr(B[i]));

end;

end.
 