unit UnitLinearCircuit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, CircuitProblem, CuBLASMtxVec, DENewtonSolver, StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    CircuitProblem: TLinearAmplifier;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var i: integer;
    sol: TVec;
begin
  CircuitProblem:= TLinearAmplifier.Create;
  sol:= TVec(CircuitProblem.DCAnalysis);
  for i:=0 to sol.length-1 do
    Memo1.Lines.Add(FloattoStr(sol[i]));
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Memo1.Clear;
end;

end.
